version: '3.8'

stack: ketone

x-db_template: &db_template
  image: postgres:12
  environment:
    - COMPOSE_CONVERT_WINDOWS_PATHS=1
    - PGDATA=/var/lib/postgresql/data/ketone
    - POSTGRES_PASSWORD=pw
    - POSTGRES_USER=user
  healthcheck:
    test: [ "CMD-SHELL", "pg_isready -U user" ]
    interval: 10s
    timeout: 5s
    retries: 5
  deploy:
    replicas: 1
    restart_policy:
      condition: any

x-net_env: &net_env
  MIGRATE: auto
  BLOBBER_PW: BLOOP_BLOOP
  BLOBBER_PRIVATE: http://blobber:9000/
  BLOBBER_PUBLIC: http://files.localhost:5000/
  COMPOSE_CONVERT_WINDOWS_PATHS: 1
  ASPNETCORE_ENVIRONMENT: Development
  ASPNETCORE_URLS: http://+:80
  POSTGRES_PASSWORD: pw
  POSTGRES_USER: user

x-net_template: &net_template
  healthcheck:
    test: curl http://localhost
    interval: 10s
    timeout: 5s
    retries: 5

  deploy:
    replicas: 1
    restart_policy:
      condition: any

services:

  # Admins

  rp:
    image: tf
    ports:
      - "5050:80"
    volumes:
      - //var/run/docker.sock:/var/run/docker.sock
  adminer:
    image: admin
    ports:
      - 5800:8080
    deploy:
      restart_policy:
        condition: any

  blobber:
    image: kirinnee/blobber:latest
    deploy:
      restart_policy:
        condition: any
    volumes:
      - blobber-data:/data
    ports:
      - 5801:9000
    environment:
      BLOBBER_PW: BLOOP_BLOOP
      BLOBBER_PORT: 9000
      BLOBBER_DIR: "/data"
      BLOBBER_CORS: "*"
  # Services
  core:
    <<: *net_template
    image: core
    ports:
      - 5051:80
    depends_on:
      - core-db
    environment:
      <<: *net_env
  core-db:
    <<: *db_template
    ports:
      - 5450:5432
    volumes:
      - ketone-core-db:/var/lib/postgresql/data/ketone

# volumes
volumes:
  blobber-data:
    external: true
  ketone-core-db:
    external: true

# images
images:
  core: 
    context: .
    file: Core.Dockerfile
  admin:latest: services/adminer
  tf: services/traefik